package org.aaron.newttest;

import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLProfile;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.SwingUtilities;

import com.jogamp.newt.awt.NewtCanvasAWT;
import com.jogamp.newt.opengl.GLWindow;

public class NEWTTest extends JFrame {

	private static final long serialVersionUID = 1L;

	private int numNewtCanvasAWTs = 0;

	public NEWTTest() {
		final JDesktopPane desktopPane = new JDesktopPane();
		JInternalFrame internalFrame;

		internalFrame = new JInternalFrame("1");
		internalFrame.setSize(150, 150);
		internalFrame.setResizable(true);
		internalFrame.setVisible(true);
		internalFrame.setMaximizable(true);
		internalFrame.getContentPane().add(createNewtCanvasAWT());
		desktopPane.add(internalFrame);

		internalFrame = new JInternalFrame("2");
		internalFrame.setSize(150, 150);
		internalFrame.setResizable(true);
		internalFrame.setVisible(true);
		internalFrame.setMaximizable(true);
		internalFrame.getContentPane().add(createNewtCanvasAWT());
		desktopPane.add(internalFrame);

		setContentPane(desktopPane);
		setSize(300, 300);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	private NewtCanvasAWT createNewtCanvasAWT() {
		final GLProfile glProfile = GLProfile.getDefault();
		final GLCapabilities glCapabilities = new GLCapabilities(glProfile);
		final GLWindow glWindow = GLWindow.create(glCapabilities);
		final Gears gears = new Gears();
		glWindow.addGLEventListener(gears);
		glWindow.enablePerfLog(true);
		final NewtCanvasAWT newtCanvasAWT = new NewtCanvasAWT(glWindow);

		new Thread(new Runnable() {
			@Override
			public void run() {
				while (true) {
					glWindow.display();
				}
			}
		}, "NewtRedrawThread-" + numNewtCanvasAWTs).start();
		++numNewtCanvasAWTs;

		return newtCanvasAWT;
	}

	public static void main(String[] args) {
		GLProfile.initSingleton(true);

		SwingUtilities.invokeLater(new Runnable() {

			@Override
			public void run() {
				new NEWTTest();
			}

		});
	}

}
